function Sigma_sme=ReconsAccur(Phi_opt,Psi,X,Y,K)
%==========================================================================
%in this function we will calculate the reconstraction accuracy 
%
%Input: Phi_opt,the optimal sensing matrix designed by the Gradient_NASMO
%       Psi,the Dictionary
%       X,the pure or the real signal 
%       Y,the measurment value
%       K,the sparsity used in OMP
%      
%Output: Sigma_sme,the reconstraction accuracy
%                  Xiao Li NOV. 2014
%==========================================================================

[N,J] = size(X);
D = Phi_opt*Psi;     %the equivalent dictionary
S = OMP(D,Y,K);
X_hat = Psi * S;
% Sigma_sme = 2*(norm(X,'fro'))^2 / (norm(X-X_hat,'fro'))^2 / param.N / param.J;
Sigma_sme =  (norm(X-X_hat,'fro'))^2 / N / J ;
end



% function [A]=OMP(D,X,L)
% % ========================================================
% % Sparse coding of a group of signals based on a given dictionary and specified number of
% % atoms to use.     X=DA
% % input arguments:  D - the dictionary
% %                   X - the signals to represent
% %                   L - the maximum number of coefficients to use in OMP
% % output arguments: A - sparse coefficient matrix.
% % ========================================================
% [n,P]=size(X);  %(^SS^):there are P signals with n dimensions
% [n,K]=size(D);  %(^SS^):the dictionary is n-by-K
% for k=1:1:P,    %(^SS^):źνϡ
%     a=[];       %(^SS^):ʼΪ
%     x=X(:,k);   %(^SS^):get the k-th signal and give it to x
%     residual=x; %(^SS^):initialize the residual
%     indx=zeros(L,1);%(^SS^):L - the maximum number of coefficients to use in OMPindx-the solution supportԪλ
%     for j=1:1:L
%         proj=D'*residual;%DresidualڻڻĽֵԽԽǿ
%         [maxVal,pos]=max(abs(proj));
%         pos=pos(1);%ֻҪһλþͺ
%         indx(j)=pos;
%         a=pinv(D(:,indx(1:j)))*x;%pinv α棬aD(:,indx(1:j))ͬά
%         residual=x-D(:,indx(1:j))*a;
%         if sum(residual.^2) < 1e-6
%             break;
%         end
%     end;
%     temp=zeros(K,1);    %(^SS^):ֵDKУaKУtempΪAʼ
%     temp(indx(1:j))=a;  %(^SS^):atempķ㲿
%     A(:,k)=sparse(temp);%(^SS^):tempȥAĵk
% 
% end;
% end
